program decypt;
uses crt;
type
 charray = array[1..25] of char;    {array used to store decrypted data}
var
 f1, f2, f3 : text;
 filename : string;
 k,j : integer;
 c : charray;
 key, num : longint;
begin
 clrscr;
 if paramstr(1) = '' then begin   {parameter 1 autoloads the file you wish
                                   to decrypt}
  writeln ('What is the name of the file you wish to decrypt? ');
  readln(filename);
 end
 else begin
  filename := paramstr(1);
 end;
 writeln ('What is your key? ');
 readln (key);
 assign(f1, filename);
 rename (f1, 'abcdeff.txt');   {renames the original file to a temporary}
 reset(f1);
 assign(f2, 'ffedcba.txt');    {creates a temporary file}
 rewrite(f2);
 repeat
  k := 0;
  repeat
   k := k + 1;
   read(f1, c[k]);               {reads 1 char from the encrytped file}
   num := ord(c[k]) - key;       {messes with the ascii value to decrypt it}
   c[k] := chr(num);             {and changes the ascii value back to a char}
  until (k >= 25) or (eof(f1));    {Every 25 chars are written to file.  This
                                    can be easily changed, but it helps to
                                    dump to a file as to keep the array size
                                    down but keeps the speed up by not writing
                                    to the file every character}
  for j := 1 to k do              {writes the chars to file}
   write(f2, c[j]);
 until eof(f1);                  {continues until there is nothing left to
                                 decrypt (end of file)}
 close(F1);
 close(f2);
 rename(f2, filename);          {renames the decrypted temp back to the
                                original file name}
 erase (f1);                  {erases the temp}
 clrscr;
end.

{Made by Pingo.  Don't use without giving credit to me!}